unit uCalcThread;

interface

uses
  Classes, SysUtils;

Type

  TOnMsg = procedure(AMsg: string) of object;
  // ¼Լ OnXXX 

  TCalcThread = class; // ǰ, TCalcThread һ

  TOnCalcOver = procedure(Sender: TCalcThread) of object;
  // ûһ䣬ʱ Sender ֻΪ TObject
  // ֱۣ㣬ǿת

  TCalcInfo = record //һ¼壬㴫
    StartNum: integer;
    EndNum: integer;
    OnMsg: TOnMsg;
    OnCalcOver: TOnCalcOver;
    ID: integer;
  end;

  TCalcThread = class(TThread) // ̳ TThread
  private
    FStartNum: integer;
    FEndNum: integer;
    FOnMsg: TOnMsg;
    FOnCalcOver: TOnCalcOver;
    FID: integer;
    procedure DoOnMsg(AMsg: string);
    procedure DoOnCalcOver;
    procedure SetOnMsg(val: TOnMsg);
    procedure SetOnCalcOver(val: TOnCalcOver);
  protected
    procedure Execute; override;
  public
    constructor Create(ACalcInfo: TCalcInfo); reintroduce;
    // reintroduce Ǹı Create 
  public
    Sum: integer; //ۼӽд public У߷
    // ǰһдһ Property Sum:integer
    // 룬ʱһ򵥱дʵá
    property OnMsg: TOnMsg read FOnMsg write SetOnMsg;
    property OnCalcOver: TOnCalcOver read FOnCalcOver write SetOnCalcOver;
  end;

implementation

{ TCalcThread }

constructor TCalcThread.Create(ACalcInfo: TCalcInfo);
begin

  Sum := 0; // ʼ

  // ΪҪѲΪ TCalcInfo
  // ߳Ծġ
  // Ϊ趨̴߳Ҫִ
  // ڴʱܰѸ¼ֵ߳࣬

  // Ȼ,Ϊ˽ѧĿĲģʵʹọ̃߳з
  // ԭ delphi ߰汾УѾ׼߳ʹ suspend-,resume-ѣֹˡ
  // οд TSimpleThread ࣬ TEvent ʵˡ롰"

  FStartNum := ACalcInfo.StartNum;
  FEndNum := ACalcInfo.EndNum;
  FID := ACalcInfo.ID;

  self.OnMsg := ACalcInfo.OnMsg;
  // ȼ  FOnMsg:=ACalcInfo.OnMsg;
  // ֲͬΪ OnMsg ̶߳⹫
  //  SetOnMsg У趨
  // Ϊľ֮һҲ!
  self.OnCalcOver := ACalcInfo.OnCalcOver;

  inherited Create(false);
  // false ִָ̺߳ Execute еĴ
  FreeOnTerminate := true; // ˳ execute к󣬴߳Զͷ
end;

procedure TCalcThread.DoOnCalcOver;
begin
  // дǷ
  if Assigned(FOnCalcOver) then
    FOnCalcOver(self);
end;

procedure TCalcThread.DoOnMsg(AMsg: string);
begin
  if Assigned(FOnMsg) then
    FOnMsg(AMsg);
end;

procedure TCalcThread.Execute;
var
  i: integer;
  sMsg: string;
begin
  inherited;

  // ˴Ĵ룬߳̿ռеġ
  // ߳Create ֮󣬾ͻϿʼִд˴Ĵ롣

  // ˴õЩҲڱ߳̿ռУ
  // ̴߳룬ǿںδУдʲôطûйϵм!

  sMsg := '߳ID:' + IntToStr(FID) + ',:' + IntToStr(FStartNum) + ',ֹ:' + IntToStr(FEndNum);

  DoOnMsg(sMsg); // ʾϢ,ʾ߳̿ʼ
  // ˴ñĵԪĴ룬ôЩҲ߳̿ռ
  // ߳еĴ벻׼ VCL ԣҪЩִ߳
  //  TFrmCalc ˵

  for i := FStartNum to FEndNum do
  begin
    Sum := Sum + i;
    sleep(1); // üģʵʹĺʱ
  end;

  sMsg := '߳ID:' + IntToStr(FID) + ',:' + IntToStr(Sum);
  DoOnMsg(sMsg);

  DoOnCalcOver; // ֪ͨߣ

end;

procedure TCalcThread.SetOnMsg(val: TOnMsg);
begin
  FOnMsg := val;
end;

procedure TCalcThread.SetOnCalcOver(val: TOnCalcOver);
begin
  FOnCalcOver := val;
end;

end.
